/*******************************************************************************
* File Name: emFile_SCB_SPI_0_SCBCLK.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_emFile_SCB_SPI_0_SCBCLK_H)
#define CY_CLOCK_emFile_SCB_SPI_0_SCBCLK_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void emFile_SCB_SPI_0_SCBCLK_StartEx(uint32 alignClkDiv);
#define emFile_SCB_SPI_0_SCBCLK_Start() \
    emFile_SCB_SPI_0_SCBCLK_StartEx(emFile_SCB_SPI_0_SCBCLK__PA_DIV_ID)

#else

void emFile_SCB_SPI_0_SCBCLK_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void emFile_SCB_SPI_0_SCBCLK_Stop(void);

void emFile_SCB_SPI_0_SCBCLK_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 emFile_SCB_SPI_0_SCBCLK_GetDividerRegister(void);
uint8  emFile_SCB_SPI_0_SCBCLK_GetFractionalDividerRegister(void);

#define emFile_SCB_SPI_0_SCBCLK_Enable()                         emFile_SCB_SPI_0_SCBCLK_Start()
#define emFile_SCB_SPI_0_SCBCLK_Disable()                        emFile_SCB_SPI_0_SCBCLK_Stop()
#define emFile_SCB_SPI_0_SCBCLK_SetDividerRegister(clkDivider, reset)  \
    emFile_SCB_SPI_0_SCBCLK_SetFractionalDividerRegister((clkDivider), 0u)
#define emFile_SCB_SPI_0_SCBCLK_SetDivider(clkDivider)           emFile_SCB_SPI_0_SCBCLK_SetDividerRegister((clkDivider), 1u)
#define emFile_SCB_SPI_0_SCBCLK_SetDividerValue(clkDivider)      emFile_SCB_SPI_0_SCBCLK_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define emFile_SCB_SPI_0_SCBCLK_DIV_ID     emFile_SCB_SPI_0_SCBCLK__DIV_ID

#define emFile_SCB_SPI_0_SCBCLK_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define emFile_SCB_SPI_0_SCBCLK_CTRL_REG   (*(reg32 *)emFile_SCB_SPI_0_SCBCLK__CTRL_REGISTER)
#define emFile_SCB_SPI_0_SCBCLK_DIV_REG    (*(reg32 *)emFile_SCB_SPI_0_SCBCLK__DIV_REGISTER)

#define emFile_SCB_SPI_0_SCBCLK_CMD_DIV_SHIFT          (0u)
#define emFile_SCB_SPI_0_SCBCLK_CMD_PA_DIV_SHIFT       (8u)
#define emFile_SCB_SPI_0_SCBCLK_CMD_DISABLE_SHIFT      (30u)
#define emFile_SCB_SPI_0_SCBCLK_CMD_ENABLE_SHIFT       (31u)

#define emFile_SCB_SPI_0_SCBCLK_CMD_DISABLE_MASK       ((uint32)((uint32)1u << emFile_SCB_SPI_0_SCBCLK_CMD_DISABLE_SHIFT))
#define emFile_SCB_SPI_0_SCBCLK_CMD_ENABLE_MASK        ((uint32)((uint32)1u << emFile_SCB_SPI_0_SCBCLK_CMD_ENABLE_SHIFT))

#define emFile_SCB_SPI_0_SCBCLK_DIV_FRAC_MASK  (0x000000F8u)
#define emFile_SCB_SPI_0_SCBCLK_DIV_FRAC_SHIFT (3u)
#define emFile_SCB_SPI_0_SCBCLK_DIV_INT_MASK   (0xFFFFFF00u)
#define emFile_SCB_SPI_0_SCBCLK_DIV_INT_SHIFT  (8u)

#else 

#define emFile_SCB_SPI_0_SCBCLK_DIV_REG        (*(reg32 *)emFile_SCB_SPI_0_SCBCLK__REGISTER)
#define emFile_SCB_SPI_0_SCBCLK_ENABLE_REG     emFile_SCB_SPI_0_SCBCLK_DIV_REG
#define emFile_SCB_SPI_0_SCBCLK_DIV_FRAC_MASK  emFile_SCB_SPI_0_SCBCLK__FRAC_MASK
#define emFile_SCB_SPI_0_SCBCLK_DIV_FRAC_SHIFT (16u)
#define emFile_SCB_SPI_0_SCBCLK_DIV_INT_MASK   emFile_SCB_SPI_0_SCBCLK__DIVIDER_MASK
#define emFile_SCB_SPI_0_SCBCLK_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_emFile_SCB_SPI_0_SCBCLK_H) */

/* [] END OF FILE */
