/*******************************************************************************
* File Name: emFile_SCB_SPI_0_SPI_UART.h
* Version 3.0
*
* Description:
*  This file provides constants and parameter values for the SCB Component in
*  SPI and UART modes.
*
* Note:
*
********************************************************************************
* Copyright 2013-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_SPI_UART_emFile_SCB_SPI_0_H)
#define CY_SCB_SPI_UART_emFile_SCB_SPI_0_H

#include "emFile_SCB_SPI_0.h"


/***************************************
*   SPI Initial Parameter Constants
****************************************/

#define emFile_SCB_SPI_0_SPI_MODE                   (1u)
#define emFile_SCB_SPI_0_SPI_SUB_MODE               (0u)
#define emFile_SCB_SPI_0_SPI_CLOCK_MODE             (0u)
#define emFile_SCB_SPI_0_SPI_OVS_FACTOR             (6u)
#define emFile_SCB_SPI_0_SPI_MEDIAN_FILTER_ENABLE   (0u)
#define emFile_SCB_SPI_0_SPI_LATE_MISO_SAMPLE_ENABLE (0u)
#define emFile_SCB_SPI_0_SPI_RX_DATA_BITS_NUM       (8u)
#define emFile_SCB_SPI_0_SPI_TX_DATA_BITS_NUM       (8u)
#define emFile_SCB_SPI_0_SPI_WAKE_ENABLE            (0u)
#define emFile_SCB_SPI_0_SPI_BITS_ORDER             (1u)
#define emFile_SCB_SPI_0_SPI_TRANSFER_SEPARATION    (1u)
#define emFile_SCB_SPI_0_SPI_NUMBER_OF_SS_LINES     (1u)
#define emFile_SCB_SPI_0_SPI_RX_BUFFER_SIZE         (8u)
#define emFile_SCB_SPI_0_SPI_TX_BUFFER_SIZE         (8u)

#define emFile_SCB_SPI_0_SPI_INTERRUPT_MODE         (0u)

#define emFile_SCB_SPI_0_SPI_INTR_RX_MASK           (0u)
#define emFile_SCB_SPI_0_SPI_INTR_TX_MASK           (0u)

#define emFile_SCB_SPI_0_SPI_RX_TRIGGER_LEVEL       (7u)
#define emFile_SCB_SPI_0_SPI_TX_TRIGGER_LEVEL       (0u)

#define emFile_SCB_SPI_0_SPI_BYTE_MODE_ENABLE       (0u)
#define emFile_SCB_SPI_0_SPI_FREE_RUN_SCLK_ENABLE   (0u)
#define emFile_SCB_SPI_0_SPI_SS0_POLARITY           (0u)
#define emFile_SCB_SPI_0_SPI_SS1_POLARITY           (0u)
#define emFile_SCB_SPI_0_SPI_SS2_POLARITY           (0u)
#define emFile_SCB_SPI_0_SPI_SS3_POLARITY           (0u)


/***************************************
*   UART Initial Parameter Constants
****************************************/

#define emFile_SCB_SPI_0_UART_SUB_MODE              (0u)
#define emFile_SCB_SPI_0_UART_DIRECTION             (3u)
#define emFile_SCB_SPI_0_UART_DATA_BITS_NUM         (8u)
#define emFile_SCB_SPI_0_UART_PARITY_TYPE           (2u)
#define emFile_SCB_SPI_0_UART_STOP_BITS_NUM         (2u)
#define emFile_SCB_SPI_0_UART_OVS_FACTOR            (12u)
#define emFile_SCB_SPI_0_UART_IRDA_LOW_POWER        (0u)
#define emFile_SCB_SPI_0_UART_MEDIAN_FILTER_ENABLE  (0u)
#define emFile_SCB_SPI_0_UART_RETRY_ON_NACK         (0u)
#define emFile_SCB_SPI_0_UART_IRDA_POLARITY         (0u)
#define emFile_SCB_SPI_0_UART_DROP_ON_FRAME_ERR     (0u)
#define emFile_SCB_SPI_0_UART_DROP_ON_PARITY_ERR    (0u)
#define emFile_SCB_SPI_0_UART_WAKE_ENABLE           (0u)
#define emFile_SCB_SPI_0_UART_RX_BUFFER_SIZE        (8u)
#define emFile_SCB_SPI_0_UART_TX_BUFFER_SIZE        (8u)
#define emFile_SCB_SPI_0_UART_MP_MODE_ENABLE        (0u)
#define emFile_SCB_SPI_0_UART_MP_ACCEPT_ADDRESS     (0u)
#define emFile_SCB_SPI_0_UART_MP_RX_ADDRESS         (2u)
#define emFile_SCB_SPI_0_UART_MP_RX_ADDRESS_MASK    (255u)

#define emFile_SCB_SPI_0_UART_INTERRUPT_MODE        (0u)

#define emFile_SCB_SPI_0_UART_INTR_RX_MASK          (0u)
#define emFile_SCB_SPI_0_UART_INTR_TX_MASK          (0u)

#define emFile_SCB_SPI_0_UART_RX_TRIGGER_LEVEL      (7u)
#define emFile_SCB_SPI_0_UART_TX_TRIGGER_LEVEL      (0u)

#define emFile_SCB_SPI_0_UART_BYTE_MODE_ENABLE      (0u)
#define emFile_SCB_SPI_0_UART_CTS_ENABLE            (0u)
#define emFile_SCB_SPI_0_UART_CTS_POLARITY          (0u)
#define emFile_SCB_SPI_0_UART_RTS_ENABLE            (0u)
#define emFile_SCB_SPI_0_UART_RTS_POLARITY          (0u)
#define emFile_SCB_SPI_0_UART_RTS_FIFO_LEVEL        (4u)

/* SPI mode enum */
#define emFile_SCB_SPI_0_SPI_SLAVE  (0u)
#define emFile_SCB_SPI_0_SPI_MASTER (1u)

/* UART direction enum */
#define emFile_SCB_SPI_0_UART_RX    (1u)
#define emFile_SCB_SPI_0_UART_TX    (2u)
#define emFile_SCB_SPI_0_UART_TX_RX (3u)


/***************************************
*   Conditional Compilation Parameters
****************************************/

#if(emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG)

    /* Mode */
    #define emFile_SCB_SPI_0_SPI_SLAVE_CONST        (1u)
    #define emFile_SCB_SPI_0_SPI_MASTER_CONST       (1u)

    /* Direction */
    #define emFile_SCB_SPI_0_RX_DIRECTION           (1u)
    #define emFile_SCB_SPI_0_TX_DIRECTION           (1u)
    #define emFile_SCB_SPI_0_UART_RX_DIRECTION      (1u)
    #define emFile_SCB_SPI_0_UART_TX_DIRECTION      (1u)

    /* Only external RX and TX buffer for Uncofigured mode */
    #define emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER   (0u)
    #define emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER   (0u)

    /* Get RX and TX buffer size */
    #define emFile_SCB_SPI_0_INTERNAL_RX_BUFFER_SIZE    (emFile_SCB_SPI_0_rxBufferSize + 1u)
    #define emFile_SCB_SPI_0_RX_BUFFER_SIZE             (emFile_SCB_SPI_0_rxBufferSize)
    #define emFile_SCB_SPI_0_TX_BUFFER_SIZE             (emFile_SCB_SPI_0_txBufferSize)

    /* Return true if buffer is provided */
    #define emFile_SCB_SPI_0_CHECK_RX_SW_BUFFER (NULL != emFile_SCB_SPI_0_rxBuffer)
    #define emFile_SCB_SPI_0_CHECK_TX_SW_BUFFER (NULL != emFile_SCB_SPI_0_txBuffer)

    /* Always provide global variables to support RX and TX buffers */
    #define emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER_CONST    (1u)
    #define emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER_CONST    (1u)

    /* Get wakeup enable option */
    #define emFile_SCB_SPI_0_SPI_WAKE_ENABLE_CONST  (1u)
    #define emFile_SCB_SPI_0_CHECK_SPI_WAKE_ENABLE  (0u != emFile_SCB_SPI_0_scbEnableWake)
    #define emFile_SCB_SPI_0_UART_WAKE_ENABLE_CONST (1u)

    /* SPI/UART: TX or RX FIFO size */
    #if (emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1)
        #define emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE             (emFile_SCB_SPI_0_FIFO_SIZE)
        #define emFile_SCB_SPI_0_CHECK_UART_RTS_CONTROL_FLOW    (0u)
    #else
        #define emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE (emFile_SCB_SPI_0_GET_FIFO_SIZE(emFile_SCB_SPI_0_CTRL_REG & \
                                                                                    emFile_SCB_SPI_0_CTRL_BYTE_MODE))

        #define emFile_SCB_SPI_0_CHECK_UART_RTS_CONTROL_FLOW \
                    ((emFile_SCB_SPI_0_SCB_MODE_UART_RUNTM_CFG) && \
                     (0u != emFile_SCB_SPI_0_GET_UART_FLOW_CTRL_TRIGGER_LEVEL(emFile_SCB_SPI_0_UART_FLOW_CTRL_REG)))
    #endif /* (emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1) */

#else

    /* Internal RX and TX buffer: for SPI or UART */
    #if (emFile_SCB_SPI_0_SCB_MODE_SPI_CONST_CFG)

        /* SPI Direction */
        #define emFile_SCB_SPI_0_SPI_RX_DIRECTION (1u)
        #define emFile_SCB_SPI_0_SPI_TX_DIRECTION (1u)

        /* Get FIFO size */
        #if (emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1)
            #define emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE    (emFile_SCB_SPI_0_FIFO_SIZE)
        #else
            #define emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE \
                                           emFile_SCB_SPI_0_GET_FIFO_SIZE(emFile_SCB_SPI_0_SPI_BYTE_MODE_ENABLE)

        #endif /* (emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1) */

        /* SPI internal RX and TX buffers */
        #define emFile_SCB_SPI_0_INTERNAL_SPI_RX_SW_BUFFER  (emFile_SCB_SPI_0_SPI_RX_BUFFER_SIZE > \
                                                                emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE)
        #define emFile_SCB_SPI_0_INTERNAL_SPI_TX_SW_BUFFER  (emFile_SCB_SPI_0_SPI_TX_BUFFER_SIZE > \
                                                                emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE)

        /* Internal SPI RX and TX buffer */
        #define emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER  (emFile_SCB_SPI_0_INTERNAL_SPI_RX_SW_BUFFER)
        #define emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER  (emFile_SCB_SPI_0_INTERNAL_SPI_TX_SW_BUFFER)

        /* Internal SPI RX and TX buffer size */
        #define emFile_SCB_SPI_0_INTERNAL_RX_BUFFER_SIZE    (emFile_SCB_SPI_0_SPI_RX_BUFFER_SIZE + 1u)
        #define emFile_SCB_SPI_0_RX_BUFFER_SIZE             (emFile_SCB_SPI_0_SPI_RX_BUFFER_SIZE)
        #define emFile_SCB_SPI_0_TX_BUFFER_SIZE             (emFile_SCB_SPI_0_SPI_TX_BUFFER_SIZE)

        /* Get wakeup enable option */
        #define emFile_SCB_SPI_0_SPI_WAKE_ENABLE_CONST  (0u != emFile_SCB_SPI_0_SPI_WAKE_ENABLE)
        #define emFile_SCB_SPI_0_UART_WAKE_ENABLE_CONST (0u)

    #else

        /* UART Direction */
        #define emFile_SCB_SPI_0_UART_RX_DIRECTION (0u != (emFile_SCB_SPI_0_UART_DIRECTION & emFile_SCB_SPI_0_UART_RX))
        #define emFile_SCB_SPI_0_UART_TX_DIRECTION (0u != (emFile_SCB_SPI_0_UART_DIRECTION & emFile_SCB_SPI_0_UART_TX))

        /* Get FIFO size */
        #if (emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1)
            #define emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE    (emFile_SCB_SPI_0_FIFO_SIZE)
        #else
            #define emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE \
                                           emFile_SCB_SPI_0_GET_FIFO_SIZE(emFile_SCB_SPI_0_UART_BYTE_MODE_ENABLE)
        #endif /* (emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1) */

        /* UART internal RX and TX buffers */
        #define emFile_SCB_SPI_0_INTERNAL_UART_RX_SW_BUFFER  (emFile_SCB_SPI_0_UART_RX_BUFFER_SIZE > \
                                                                emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE)
        #define emFile_SCB_SPI_0_INTERNAL_UART_TX_SW_BUFFER  (emFile_SCB_SPI_0_UART_TX_BUFFER_SIZE > \
                                                                    emFile_SCB_SPI_0_SPI_UART_FIFO_SIZE)

        /* Internal UART RX and TX buffer */
        #define emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER  (emFile_SCB_SPI_0_INTERNAL_UART_RX_SW_BUFFER)
        #define emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER  (emFile_SCB_SPI_0_INTERNAL_UART_TX_SW_BUFFER)

        /* Internal UART RX and TX buffer size */
        #define emFile_SCB_SPI_0_INTERNAL_RX_BUFFER_SIZE    (emFile_SCB_SPI_0_UART_RX_BUFFER_SIZE + 1u)
        #define emFile_SCB_SPI_0_RX_BUFFER_SIZE             (emFile_SCB_SPI_0_UART_RX_BUFFER_SIZE)
        #define emFile_SCB_SPI_0_TX_BUFFER_SIZE             (emFile_SCB_SPI_0_UART_TX_BUFFER_SIZE)

        /* Get wakeup enable option */
        #define emFile_SCB_SPI_0_SPI_WAKE_ENABLE_CONST  (0u)
        #define emFile_SCB_SPI_0_UART_WAKE_ENABLE_CONST (0u != emFile_SCB_SPI_0_UART_WAKE_ENABLE)

    #endif /* (emFile_SCB_SPI_0_SCB_MODE_SPI_CONST_CFG) */

    /* Mode */
    #define emFile_SCB_SPI_0_SPI_SLAVE_CONST    (emFile_SCB_SPI_0_SPI_MODE == emFile_SCB_SPI_0_SPI_SLAVE)
    #define emFile_SCB_SPI_0_SPI_MASTER_CONST   (emFile_SCB_SPI_0_SPI_MODE == emFile_SCB_SPI_0_SPI_MASTER)

    /* Direction */
    #define emFile_SCB_SPI_0_RX_DIRECTION ((emFile_SCB_SPI_0_SCB_MODE_SPI_CONST_CFG) ? \
                                            (emFile_SCB_SPI_0_SPI_RX_DIRECTION) : (emFile_SCB_SPI_0_UART_RX_DIRECTION))

    #define emFile_SCB_SPI_0_TX_DIRECTION ((emFile_SCB_SPI_0_SCB_MODE_SPI_CONST_CFG) ? \
                                            (emFile_SCB_SPI_0_SPI_TX_DIRECTION) : (emFile_SCB_SPI_0_UART_TX_DIRECTION))

    /* Internal RX and TX buffer: for SPI or UART. Used in conditional compilation check */
    #define emFile_SCB_SPI_0_CHECK_RX_SW_BUFFER (emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER)
    #define emFile_SCB_SPI_0_CHECK_TX_SW_BUFFER (emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER)

    /* Provide global variables to support RX and TX buffers */
    #define emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER_CONST    (emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER)
    #define emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER_CONST    (emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER)

    /* SPI wakeup */
    #define emFile_SCB_SPI_0_CHECK_SPI_WAKE_ENABLE  (emFile_SCB_SPI_0_SPI_WAKE_ENABLE_CONST)

    /* UART flow control: not applicable for CY_SCBIP_V0 || CY_SCBIP_V1 */
    #define emFile_SCB_SPI_0_CHECK_UART_RTS_CONTROL_FLOW    (emFile_SCB_SPI_0_SCB_MODE_UART_CONST_CFG && \
                                                             emFile_SCB_SPI_0_UART_RTS_ENABLE)

#endif /* End (emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG) */


/***************************************
*       Type Definitions
***************************************/

/* emFile_SCB_SPI_0_SPI_INIT_STRUCT */
typedef struct
{
    uint32 mode;
    uint32 submode;
    uint32 sclkMode;
    uint32 oversample;
    uint32 enableMedianFilter;
    uint32 enableLateSampling;
    uint32 enableWake;
    uint32 rxDataBits;
    uint32 txDataBits;
    uint32 bitOrder;
    uint32 transferSeperation;
    uint32 rxBufferSize;
    uint8* rxBuffer;
    uint32 txBufferSize;
    uint8* txBuffer;
    uint32 enableInterrupt;
    uint32 rxInterruptMask;
    uint32 rxTriggerLevel;
    uint32 txInterruptMask;
    uint32 txTriggerLevel;
    uint8 enableByteMode;
    uint8 enableFreeRunSclk;
    uint8 polaritySs;
} emFile_SCB_SPI_0_SPI_INIT_STRUCT;

/* emFile_SCB_SPI_0_UART_INIT_STRUCT */
typedef struct
{
    uint32 mode;
    uint32 direction;
    uint32 dataBits;
    uint32 parity;
    uint32 stopBits;
    uint32 oversample;
    uint32 enableIrdaLowPower;
    uint32 enableMedianFilter;
    uint32 enableRetryNack;
    uint32 enableInvertedRx;
    uint32 dropOnParityErr;
    uint32 dropOnFrameErr;
    uint32 enableWake;
    uint32 rxBufferSize;
    uint8* rxBuffer;
    uint32 txBufferSize;
    uint8* txBuffer;
    uint32 enableMultiproc;
    uint32 multiprocAcceptAddr;
    uint32 multiprocAddr;
    uint32 multiprocAddrMask;
    uint32 enableInterrupt;
    uint32 rxInterruptMask;
    uint32 rxTriggerLevel;
    uint32 txInterruptMask;
    uint32 txTriggerLevel;
    uint8 enableByteMode;
    uint8 enableCts;
    uint8 ctsPolarity;
    uint8 rtsRxFifoLevel;
    uint8 rtsPolarity;
} emFile_SCB_SPI_0_UART_INIT_STRUCT;


/***************************************
*        Function Prototypes
***************************************/

/* SPI specific functions */
#if(emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG)
    void emFile_SCB_SPI_0_SpiInit(const emFile_SCB_SPI_0_SPI_INIT_STRUCT *config);
#endif /* (emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG) */

#if(emFile_SCB_SPI_0_SCB_MODE_SPI_INC)
    #define emFile_SCB_SPI_0_SpiIsBusBusy() ((uint32) (0u != (emFile_SCB_SPI_0_SPI_STATUS_REG & \
                                                              emFile_SCB_SPI_0_SPI_STATUS_BUS_BUSY)))

    #if (emFile_SCB_SPI_0_SPI_MASTER_CONST)
        void emFile_SCB_SPI_0_SpiSetActiveSlaveSelect(uint32 slaveSelect);
    #endif /*(emFile_SCB_SPI_0_SPI_MASTER_CONST) */

    #if !(emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1)
        void emFile_SCB_SPI_0_SpiSetSlaveSelectPolarity(uint32 slaveSelect, uint32 polarity);
    #endif /* !(emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1) */
#endif /* (emFile_SCB_SPI_0_SCB_MODE_SPI_INC) */

/* UART specific functions */
#if(emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG)
    void emFile_SCB_SPI_0_UartInit(const emFile_SCB_SPI_0_UART_INIT_STRUCT *config);
#endif /* (emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG) */

#if(emFile_SCB_SPI_0_SCB_MODE_UART_INC)
    void emFile_SCB_SPI_0_UartSetRxAddress(uint32 address);
    void emFile_SCB_SPI_0_UartSetRxAddressMask(uint32 addressMask);

    /* UART RX direction APIs */
    #if(emFile_SCB_SPI_0_UART_RX_DIRECTION)
        uint32 emFile_SCB_SPI_0_UartGetChar(void);
        uint32 emFile_SCB_SPI_0_UartGetByte(void);

        #if !(emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1)
            /* UART APIs for Flow Control */
            void emFile_SCB_SPI_0_UartSetRtsPolarity(uint32 polarity);
            void emFile_SCB_SPI_0_UartSetRtsFifoLevel(uint32 level);
        #endif /* !(emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1) */
    #endif /* (emFile_SCB_SPI_0_UART_RX_DIRECTION) */

    /* UART TX direction APIs */
    #if(emFile_SCB_SPI_0_UART_TX_DIRECTION)
        #define emFile_SCB_SPI_0_UartPutChar(ch)    emFile_SCB_SPI_0_SpiUartWriteTxData((uint32)(ch))
        void emFile_SCB_SPI_0_UartPutString(const char8 string[]);
        void emFile_SCB_SPI_0_UartPutCRLF(uint32 txDataByte);

        #if !(emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1)
            /* UART APIs for Flow Control */
            void emFile_SCB_SPI_0_UartEnableCts(void);
            void emFile_SCB_SPI_0_UartDisableCts(void);
            void emFile_SCB_SPI_0_UartSetCtsPolarity(uint32 polarity);
        #endif /* !(emFile_SCB_SPI_0_CY_SCBIP_V0 || emFile_SCB_SPI_0_CY_SCBIP_V1) */
    #endif /* (emFile_SCB_SPI_0_UART_TX_DIRECTION) */
#endif /* (emFile_SCB_SPI_0_SCB_MODE_UART_INC) */

/* Common APIs RX direction */
#if(emFile_SCB_SPI_0_RX_DIRECTION)
    uint32 emFile_SCB_SPI_0_SpiUartReadRxData(void);
    uint32 emFile_SCB_SPI_0_SpiUartGetRxBufferSize(void);
    void   emFile_SCB_SPI_0_SpiUartClearRxBuffer(void);
#endif /* (emFile_SCB_SPI_0_RX_DIRECTION) */

/* Common APIs TX direction */
#if(emFile_SCB_SPI_0_TX_DIRECTION)
    void   emFile_SCB_SPI_0_SpiUartWriteTxData(uint32 txData);
    void   emFile_SCB_SPI_0_SpiUartPutArray(const uint8 wrBuf[], uint32 count);
    uint32 emFile_SCB_SPI_0_SpiUartGetTxBufferSize(void);
    void   emFile_SCB_SPI_0_SpiUartClearTxBuffer(void);
#endif /* (emFile_SCB_SPI_0_TX_DIRECTION) */

CY_ISR_PROTO(emFile_SCB_SPI_0_SPI_UART_ISR);

#if(emFile_SCB_SPI_0_UART_RX_WAKEUP_IRQ)
    CY_ISR_PROTO(emFile_SCB_SPI_0_UART_WAKEUP_ISR);
#endif /* (emFile_SCB_SPI_0_UART_RX_WAKEUP_IRQ) */


/***************************************
*     Buffer Access Macro Definitions
***************************************/

#if(emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG)
    /* RX direction */
    void   emFile_SCB_SPI_0_PutWordInRxBuffer  (uint32 idx, uint32 rxDataByte);
    uint32 emFile_SCB_SPI_0_GetWordFromRxBuffer(uint32 idx);

    /* TX direction */
    void   emFile_SCB_SPI_0_PutWordInTxBuffer  (uint32 idx, uint32 txDataByte);
    uint32 emFile_SCB_SPI_0_GetWordFromTxBuffer(uint32 idx);

#else
    /* RX direction */
    #if(emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER_CONST)
        #define emFile_SCB_SPI_0_PutWordInRxBuffer(idx, rxDataByte) \
                do{                                                 \
                    emFile_SCB_SPI_0_rxBufferInternal[(idx)] = ((uint8) (rxDataByte)); \
                }while(0)

        #define emFile_SCB_SPI_0_GetWordFromRxBuffer(idx) emFile_SCB_SPI_0_rxBufferInternal[(idx)]

    #endif /* (emFile_SCB_SPI_0_INTERNAL_RX_SW_BUFFER_CONST) */

    /* TX direction */
    #if(emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER_CONST)
        #define emFile_SCB_SPI_0_PutWordInTxBuffer(idx, txDataByte) \
                    do{                                             \
                        emFile_SCB_SPI_0_txBufferInternal[(idx)] = ((uint8) (txDataByte)); \
                    }while(0)

        #define emFile_SCB_SPI_0_GetWordFromTxBuffer(idx) emFile_SCB_SPI_0_txBufferInternal[(idx)]

    #endif /* (emFile_SCB_SPI_0_INTERNAL_TX_SW_BUFFER_CONST) */

#endif /* (emFile_SCB_SPI_0_TX_SW_BUFFER_ENABLE) */


/***************************************
*         SPI API Constants
***************************************/

/* SPI sub mode enum */
#define emFile_SCB_SPI_0_SPI_MODE_MOTOROLA      (0x00u)
#define emFile_SCB_SPI_0_SPI_MODE_TI_COINCIDES  (0x01u)
#define emFile_SCB_SPI_0_SPI_MODE_TI_PRECEDES   (0x11u)
#define emFile_SCB_SPI_0_SPI_MODE_NATIONAL      (0x02u)
#define emFile_SCB_SPI_0_SPI_MODE_MASK          (0x03u)
#define emFile_SCB_SPI_0_SPI_MODE_TI_PRECEDES_MASK  (0x10u)
#define emFile_SCB_SPI_0_SPI_MODE_NS_MICROWIRE  (emFile_SCB_SPI_0_SPI_MODE_NATIONAL)

/* SPI phase and polarity mode enum */
#define emFile_SCB_SPI_0_SPI_SCLK_CPHA0_CPOL0   (0x00u)
#define emFile_SCB_SPI_0_SPI_SCLK_CPHA0_CPOL1   (0x02u)
#define emFile_SCB_SPI_0_SPI_SCLK_CPHA1_CPOL0   (0x01u)
#define emFile_SCB_SPI_0_SPI_SCLK_CPHA1_CPOL1   (0x03u)

/* SPI bits order enum */
#define emFile_SCB_SPI_0_BITS_ORDER_LSB_FIRST   (0u)
#define emFile_SCB_SPI_0_BITS_ORDER_MSB_FIRST   (1u)

/* SPI transfer separation enum */
#define emFile_SCB_SPI_0_SPI_TRANSFER_SEPARATED     (0u)
#define emFile_SCB_SPI_0_SPI_TRANSFER_CONTINUOUS    (1u)

/* SPI slave select constants */
#define emFile_SCB_SPI_0_SPI_SLAVE_SELECT0    (emFile_SCB_SPI_0_SCB__SS0_POSISTION)
#define emFile_SCB_SPI_0_SPI_SLAVE_SELECT1    (emFile_SCB_SPI_0_SCB__SS1_POSISTION)
#define emFile_SCB_SPI_0_SPI_SLAVE_SELECT2    (emFile_SCB_SPI_0_SCB__SS2_POSISTION)
#define emFile_SCB_SPI_0_SPI_SLAVE_SELECT3    (emFile_SCB_SPI_0_SCB__SS3_POSISTION)

/* SPI slave select polarity settings */
#define emFile_SCB_SPI_0_SPI_SS_ACTIVE_LOW  (0u)
#define emFile_SCB_SPI_0_SPI_SS_ACTIVE_HIGH (1u)


/***************************************
*         UART API Constants
***************************************/

/* UART sub-modes enum */
#define emFile_SCB_SPI_0_UART_MODE_STD          (0u)
#define emFile_SCB_SPI_0_UART_MODE_SMARTCARD    (1u)
#define emFile_SCB_SPI_0_UART_MODE_IRDA         (2u)

/* UART direction enum */
#define emFile_SCB_SPI_0_UART_RX    (1u)
#define emFile_SCB_SPI_0_UART_TX    (2u)
#define emFile_SCB_SPI_0_UART_TX_RX (3u)

/* UART parity enum */
#define emFile_SCB_SPI_0_UART_PARITY_EVEN   (0u)
#define emFile_SCB_SPI_0_UART_PARITY_ODD    (1u)
#define emFile_SCB_SPI_0_UART_PARITY_NONE   (2u)

/* UART stop bits enum */
#define emFile_SCB_SPI_0_UART_STOP_BITS_1   (2u)
#define emFile_SCB_SPI_0_UART_STOP_BITS_1_5 (3u)
#define emFile_SCB_SPI_0_UART_STOP_BITS_2   (4u)

/* UART IrDA low power OVS enum */
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS16     (16u)
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS32     (32u)
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS48     (48u)
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS96     (96u)
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS192    (192u)
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS768    (768u)
#define emFile_SCB_SPI_0_UART_IRDA_LP_OVS1536   (1536u)

/* Uart MP: mark (address) and space (data) bit definitions */
#define emFile_SCB_SPI_0_UART_MP_MARK       (0x100u)
#define emFile_SCB_SPI_0_UART_MP_SPACE      (0x000u)

/* UART CTS/RTS polarity settings */
#define emFile_SCB_SPI_0_UART_CTS_ACTIVE_LOW    (0u)
#define emFile_SCB_SPI_0_UART_CTS_ACTIVE_HIGH   (1u)
#define emFile_SCB_SPI_0_UART_RTS_ACTIVE_LOW    (0u)
#define emFile_SCB_SPI_0_UART_RTS_ACTIVE_HIGH   (1u)

/* Sources of RX errors */
#define emFile_SCB_SPI_0_INTR_RX_ERR        (emFile_SCB_SPI_0_INTR_RX_OVERFLOW    | \
                                             emFile_SCB_SPI_0_INTR_RX_UNDERFLOW   | \
                                             emFile_SCB_SPI_0_INTR_RX_FRAME_ERROR | \
                                             emFile_SCB_SPI_0_INTR_RX_PARITY_ERROR)

/* Shifted INTR_RX_ERR defines ONLY for emFile_SCB_SPI_0_UartGetByte() */
#define emFile_SCB_SPI_0_UART_RX_OVERFLOW       (emFile_SCB_SPI_0_INTR_RX_OVERFLOW << 8u)
#define emFile_SCB_SPI_0_UART_RX_UNDERFLOW      (emFile_SCB_SPI_0_INTR_RX_UNDERFLOW << 8u)
#define emFile_SCB_SPI_0_UART_RX_FRAME_ERROR    (emFile_SCB_SPI_0_INTR_RX_FRAME_ERROR << 8u)
#define emFile_SCB_SPI_0_UART_RX_PARITY_ERROR   (emFile_SCB_SPI_0_INTR_RX_PARITY_ERROR << 8u)
#define emFile_SCB_SPI_0_UART_RX_ERROR_MASK     (emFile_SCB_SPI_0_UART_RX_OVERFLOW    | \
                                                 emFile_SCB_SPI_0_UART_RX_UNDERFLOW   | \
                                                 emFile_SCB_SPI_0_UART_RX_FRAME_ERROR | \
                                                 emFile_SCB_SPI_0_UART_RX_PARITY_ERROR)


/***************************************
*     Vars with External Linkage
***************************************/

#if(emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG)
    extern const emFile_SCB_SPI_0_SPI_INIT_STRUCT  emFile_SCB_SPI_0_configSpi;
    extern const emFile_SCB_SPI_0_UART_INIT_STRUCT emFile_SCB_SPI_0_configUart;
#endif /* (emFile_SCB_SPI_0_SCB_MODE_UNCONFIG_CONST_CFG) */


/***************************************
*    Specific SPI Macro Definitions
***************************************/

#define emFile_SCB_SPI_0_GET_SPI_INTR_SLAVE_MASK(sourceMask)  ((sourceMask) & emFile_SCB_SPI_0_INTR_SLAVE_SPI_BUS_ERROR)
#define emFile_SCB_SPI_0_GET_SPI_INTR_MASTER_MASK(sourceMask) ((sourceMask) & emFile_SCB_SPI_0_INTR_MASTER_SPI_DONE)
#define emFile_SCB_SPI_0_GET_SPI_INTR_RX_MASK(sourceMask) \
                                             ((sourceMask) & (uint32) ~emFile_SCB_SPI_0_INTR_SLAVE_SPI_BUS_ERROR)

#define emFile_SCB_SPI_0_GET_SPI_INTR_TX_MASK(sourceMask) \
                                             ((sourceMask) & (uint32) ~emFile_SCB_SPI_0_INTR_MASTER_SPI_DONE)


/***************************************
*    Specific UART Macro Definitions
***************************************/

#define emFile_SCB_SPI_0_UART_GET_CTRL_OVS_IRDA_LP(oversample) \
        ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS16   == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS16 : \
         ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS32   == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS32 : \
          ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS48   == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS48 : \
           ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS96   == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS96 : \
            ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS192  == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS192 : \
             ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS768  == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS768 : \
              ((emFile_SCB_SPI_0_UART_IRDA_LP_OVS1536 == (oversample)) ? emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS1536 : \
                                                                          emFile_SCB_SPI_0_CTRL_OVS_IRDA_LP_OVS16)))))))

#define emFile_SCB_SPI_0_GET_UART_RX_CTRL_ENABLED(direction) ((0u != (emFile_SCB_SPI_0_UART_RX & (direction))) ? \
                                                                     (emFile_SCB_SPI_0_RX_CTRL_ENABLED) : (0u))

#define emFile_SCB_SPI_0_GET_UART_TX_CTRL_ENABLED(direction) ((0u != (emFile_SCB_SPI_0_UART_TX & (direction))) ? \
                                                                     (emFile_SCB_SPI_0_TX_CTRL_ENABLED) : (0u))


/***************************************
*        SPI Register Settings
***************************************/

#define emFile_SCB_SPI_0_CTRL_SPI      (emFile_SCB_SPI_0_CTRL_MODE_SPI)
#define emFile_SCB_SPI_0_SPI_RX_CTRL   (emFile_SCB_SPI_0_RX_CTRL_ENABLED)
#define emFile_SCB_SPI_0_SPI_TX_CTRL   (emFile_SCB_SPI_0_TX_CTRL_ENABLED)


/***************************************
*       SPI Init Register Settings
***************************************/

#define emFile_SCB_SPI_0_SPI_SS_POLARITY \
             (((uint32) emFile_SCB_SPI_0_SPI_SS0_POLARITY << emFile_SCB_SPI_0_SPI_SLAVE_SELECT0) | \
              ((uint32) emFile_SCB_SPI_0_SPI_SS1_POLARITY << emFile_SCB_SPI_0_SPI_SLAVE_SELECT1) | \
              ((uint32) emFile_SCB_SPI_0_SPI_SS2_POLARITY << emFile_SCB_SPI_0_SPI_SLAVE_SELECT2) | \
              ((uint32) emFile_SCB_SPI_0_SPI_SS3_POLARITY << emFile_SCB_SPI_0_SPI_SLAVE_SELECT3))

#if(emFile_SCB_SPI_0_SCB_MODE_SPI_CONST_CFG)

    /* SPI Configuration */
    #define emFile_SCB_SPI_0_SPI_DEFAULT_CTRL \
                    (emFile_SCB_SPI_0_GET_CTRL_OVS(emFile_SCB_SPI_0_SPI_OVS_FACTOR) | \
                     emFile_SCB_SPI_0_GET_CTRL_BYTE_MODE (emFile_SCB_SPI_0_SPI_BYTE_MODE_ENABLE) | \
                     emFile_SCB_SPI_0_GET_CTRL_EC_AM_MODE(emFile_SCB_SPI_0_SPI_WAKE_ENABLE)      | \
                     emFile_SCB_SPI_0_CTRL_SPI)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_SPI_CTRL \
                    (emFile_SCB_SPI_0_GET_SPI_CTRL_CONTINUOUS    (emFile_SCB_SPI_0_SPI_TRANSFER_SEPARATION)       | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_SELECT_PRECEDE(emFile_SCB_SPI_0_SPI_SUB_MODE &                   \
                                                                  emFile_SCB_SPI_0_SPI_MODE_TI_PRECEDES_MASK)     | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_SCLK_MODE     (emFile_SCB_SPI_0_SPI_CLOCK_MODE)                | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_LATE_MISO_SAMPLE(emFile_SCB_SPI_0_SPI_LATE_MISO_SAMPLE_ENABLE) | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_SCLK_CONTINUOUS(emFile_SCB_SPI_0_SPI_FREE_RUN_SCLK_ENABLE)     | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_SSEL_POLARITY (emFile_SCB_SPI_0_SPI_SS_POLARITY)               | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_SUB_MODE      (emFile_SCB_SPI_0_SPI_SUB_MODE)                  | \
                     emFile_SCB_SPI_0_GET_SPI_CTRL_MASTER_MODE   (emFile_SCB_SPI_0_SPI_MODE))

    /* RX direction */
    #define emFile_SCB_SPI_0_SPI_DEFAULT_RX_CTRL \
                    (emFile_SCB_SPI_0_GET_RX_CTRL_DATA_WIDTH(emFile_SCB_SPI_0_SPI_RX_DATA_BITS_NUM)     | \
                     emFile_SCB_SPI_0_GET_RX_CTRL_BIT_ORDER (emFile_SCB_SPI_0_SPI_BITS_ORDER)           | \
                     emFile_SCB_SPI_0_GET_RX_CTRL_MEDIAN    (emFile_SCB_SPI_0_SPI_MEDIAN_FILTER_ENABLE) | \
                     emFile_SCB_SPI_0_SPI_RX_CTRL)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_RX_FIFO_CTRL \
                    emFile_SCB_SPI_0_GET_RX_FIFO_CTRL_TRIGGER_LEVEL(emFile_SCB_SPI_0_SPI_RX_TRIGGER_LEVEL)

    /* TX direction */
    #define emFile_SCB_SPI_0_SPI_DEFAULT_TX_CTRL \
                    (emFile_SCB_SPI_0_GET_TX_CTRL_DATA_WIDTH(emFile_SCB_SPI_0_SPI_TX_DATA_BITS_NUM) | \
                     emFile_SCB_SPI_0_GET_TX_CTRL_BIT_ORDER (emFile_SCB_SPI_0_SPI_BITS_ORDER)       | \
                     emFile_SCB_SPI_0_SPI_TX_CTRL)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_TX_FIFO_CTRL \
                    emFile_SCB_SPI_0_GET_TX_FIFO_CTRL_TRIGGER_LEVEL(emFile_SCB_SPI_0_SPI_TX_TRIGGER_LEVEL)

    /* Interrupt sources */
    #define emFile_SCB_SPI_0_SPI_DEFAULT_INTR_SPI_EC_MASK   (emFile_SCB_SPI_0_NO_INTR_SOURCES)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_INTR_I2C_EC_MASK   (emFile_SCB_SPI_0_NO_INTR_SOURCES)
    #define emFile_SCB_SPI_0_SPI_DEFAULT_INTR_SLAVE_MASK \
                    (emFile_SCB_SPI_0_SPI_INTR_RX_MASK & emFile_SCB_SPI_0_INTR_SLAVE_SPI_BUS_ERROR)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_INTR_MASTER_MASK \
                    (emFile_SCB_SPI_0_SPI_INTR_TX_MASK & emFile_SCB_SPI_0_INTR_MASTER_SPI_DONE)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_INTR_RX_MASK \
                    (emFile_SCB_SPI_0_SPI_INTR_RX_MASK & (uint32) ~emFile_SCB_SPI_0_INTR_SLAVE_SPI_BUS_ERROR)

    #define emFile_SCB_SPI_0_SPI_DEFAULT_INTR_TX_MASK \
                    (emFile_SCB_SPI_0_SPI_INTR_TX_MASK & (uint32) ~emFile_SCB_SPI_0_INTR_MASTER_SPI_DONE)

#endif /* (emFile_SCB_SPI_0_SCB_MODE_SPI_CONST_CFG) */


/***************************************
*        UART Register Settings
***************************************/

#define emFile_SCB_SPI_0_CTRL_UART      (emFile_SCB_SPI_0_CTRL_MODE_UART)
#define emFile_SCB_SPI_0_UART_RX_CTRL   (emFile_SCB_SPI_0_RX_CTRL_LSB_FIRST) /* LSB for UART goes first */
#define emFile_SCB_SPI_0_UART_TX_CTRL   (emFile_SCB_SPI_0_TX_CTRL_LSB_FIRST) /* LSB for UART goes first */


/***************************************
*      UART Init Register Settings
***************************************/

#if(emFile_SCB_SPI_0_SCB_MODE_UART_CONST_CFG)

    /* UART configuration */
    #if(emFile_SCB_SPI_0_UART_MODE_IRDA == emFile_SCB_SPI_0_UART_SUB_MODE)

        #define emFile_SCB_SPI_0_DEFAULT_CTRL_OVS   ((0u != emFile_SCB_SPI_0_UART_IRDA_LOW_POWER) ?              \
                                (emFile_SCB_SPI_0_UART_GET_CTRL_OVS_IRDA_LP(emFile_SCB_SPI_0_UART_OVS_FACTOR)) : \
                                (emFile_SCB_SPI_0_CTRL_OVS_IRDA_OVS16))

    #else

        #define emFile_SCB_SPI_0_DEFAULT_CTRL_OVS   emFile_SCB_SPI_0_GET_CTRL_OVS(emFile_SCB_SPI_0_UART_OVS_FACTOR)

    #endif /* (emFile_SCB_SPI_0_UART_MODE_IRDA == emFile_SCB_SPI_0_UART_SUB_MODE) */

    #define emFile_SCB_SPI_0_UART_DEFAULT_CTRL \
                                (emFile_SCB_SPI_0_GET_CTRL_BYTE_MODE  (emFile_SCB_SPI_0_UART_BYTE_MODE_ENABLE)  | \
                                 emFile_SCB_SPI_0_GET_CTRL_ADDR_ACCEPT(emFile_SCB_SPI_0_UART_MP_ACCEPT_ADDRESS) | \
                                 emFile_SCB_SPI_0_DEFAULT_CTRL_OVS                                              | \
                                 emFile_SCB_SPI_0_CTRL_UART)

    #define emFile_SCB_SPI_0_UART_DEFAULT_UART_CTRL \
                                    (emFile_SCB_SPI_0_GET_UART_CTRL_MODE(emFile_SCB_SPI_0_UART_SUB_MODE))

    /* RX direction */
    #define emFile_SCB_SPI_0_UART_DEFAULT_RX_CTRL_PARITY \
                                ((emFile_SCB_SPI_0_UART_PARITY_NONE != emFile_SCB_SPI_0_UART_PARITY_TYPE) ?      \
                                  (emFile_SCB_SPI_0_GET_UART_RX_CTRL_PARITY(emFile_SCB_SPI_0_UART_PARITY_TYPE) | \
                                   emFile_SCB_SPI_0_UART_RX_CTRL_PARITY_ENABLED) : (0u))

    #define emFile_SCB_SPI_0_UART_DEFAULT_UART_RX_CTRL \
                    (emFile_SCB_SPI_0_GET_UART_RX_CTRL_MODE(emFile_SCB_SPI_0_UART_STOP_BITS_NUM)                    | \
                     emFile_SCB_SPI_0_GET_UART_RX_CTRL_POLARITY(emFile_SCB_SPI_0_UART_IRDA_POLARITY)                | \
                     emFile_SCB_SPI_0_GET_UART_RX_CTRL_MP_MODE(emFile_SCB_SPI_0_UART_MP_MODE_ENABLE)                | \
                     emFile_SCB_SPI_0_GET_UART_RX_CTRL_DROP_ON_PARITY_ERR(emFile_SCB_SPI_0_UART_DROP_ON_PARITY_ERR) | \
                     emFile_SCB_SPI_0_GET_UART_RX_CTRL_DROP_ON_FRAME_ERR(emFile_SCB_SPI_0_UART_DROP_ON_FRAME_ERR)   | \
                     emFile_SCB_SPI_0_UART_DEFAULT_RX_CTRL_PARITY)

    #define emFile_SCB_SPI_0_UART_DEFAULT_RX_CTRL \
                                (emFile_SCB_SPI_0_GET_RX_CTRL_DATA_WIDTH(emFile_SCB_SPI_0_UART_DATA_BITS_NUM)        | \
                                 emFile_SCB_SPI_0_GET_RX_CTRL_MEDIAN    (emFile_SCB_SPI_0_UART_MEDIAN_FILTER_ENABLE) | \
                                 emFile_SCB_SPI_0_GET_UART_RX_CTRL_ENABLED(emFile_SCB_SPI_0_UART_DIRECTION))

    #define emFile_SCB_SPI_0_UART_DEFAULT_RX_FIFO_CTRL \
                                emFile_SCB_SPI_0_GET_RX_FIFO_CTRL_TRIGGER_LEVEL(emFile_SCB_SPI_0_UART_RX_TRIGGER_LEVEL)

    #define emFile_SCB_SPI_0_UART_DEFAULT_RX_MATCH_REG  ((0u != emFile_SCB_SPI_0_UART_MP_MODE_ENABLE) ?          \
                                (emFile_SCB_SPI_0_GET_RX_MATCH_ADDR(emFile_SCB_SPI_0_UART_MP_RX_ADDRESS) | \
                                 emFile_SCB_SPI_0_GET_RX_MATCH_MASK(emFile_SCB_SPI_0_UART_MP_RX_ADDRESS_MASK)) : (0u))

    /* TX direction */
    #define emFile_SCB_SPI_0_UART_DEFAULT_TX_CTRL_PARITY (emFile_SCB_SPI_0_UART_DEFAULT_RX_CTRL_PARITY)

    #define emFile_SCB_SPI_0_UART_DEFAULT_UART_TX_CTRL \
                                (emFile_SCB_SPI_0_GET_UART_TX_CTRL_MODE(emFile_SCB_SPI_0_UART_STOP_BITS_NUM)       | \
                                 emFile_SCB_SPI_0_GET_UART_TX_CTRL_RETRY_NACK(emFile_SCB_SPI_0_UART_RETRY_ON_NACK) | \
                                 emFile_SCB_SPI_0_UART_DEFAULT_TX_CTRL_PARITY)

    #define emFile_SCB_SPI_0_UART_DEFAULT_TX_CTRL \
                                (emFile_SCB_SPI_0_GET_TX_CTRL_DATA_WIDTH(emFile_SCB_SPI_0_UART_DATA_BITS_NUM) | \
                                 emFile_SCB_SPI_0_GET_UART_TX_CTRL_ENABLED(emFile_SCB_SPI_0_UART_DIRECTION))

    #define emFile_SCB_SPI_0_UART_DEFAULT_TX_FIFO_CTRL \
                                emFile_SCB_SPI_0_GET_TX_FIFO_CTRL_TRIGGER_LEVEL(emFile_SCB_SPI_0_UART_TX_TRIGGER_LEVEL)

    #define emFile_SCB_SPI_0_UART_DEFAULT_FLOW_CTRL \
                        (emFile_SCB_SPI_0_GET_UART_FLOW_CTRL_TRIGGER_LEVEL(emFile_SCB_SPI_0_UART_RTS_FIFO_LEVEL) | \
                         emFile_SCB_SPI_0_GET_UART_FLOW_CTRL_RTS_POLARITY (emFile_SCB_SPI_0_UART_RTS_POLARITY)   | \
                         emFile_SCB_SPI_0_GET_UART_FLOW_CTRL_CTS_POLARITY (emFile_SCB_SPI_0_UART_CTS_POLARITY)   | \
                         emFile_SCB_SPI_0_GET_UART_FLOW_CTRL_CTS_ENABLE   (emFile_SCB_SPI_0_UART_CTS_ENABLE))

    /* Interrupt sources */
    #define emFile_SCB_SPI_0_UART_DEFAULT_INTR_I2C_EC_MASK  (emFile_SCB_SPI_0_NO_INTR_SOURCES)
    #define emFile_SCB_SPI_0_UART_DEFAULT_INTR_SPI_EC_MASK  (emFile_SCB_SPI_0_NO_INTR_SOURCES)
    #define emFile_SCB_SPI_0_UART_DEFAULT_INTR_SLAVE_MASK   (emFile_SCB_SPI_0_NO_INTR_SOURCES)
    #define emFile_SCB_SPI_0_UART_DEFAULT_INTR_MASTER_MASK  (emFile_SCB_SPI_0_NO_INTR_SOURCES)
    #define emFile_SCB_SPI_0_UART_DEFAULT_INTR_RX_MASK      (emFile_SCB_SPI_0_UART_INTR_RX_MASK)
    #define emFile_SCB_SPI_0_UART_DEFAULT_INTR_TX_MASK      (emFile_SCB_SPI_0_UART_INTR_TX_MASK)

#endif /* (emFile_SCB_SPI_0_SCB_MODE_UART_CONST_CFG) */


/***************************************
* The following code is DEPRECATED and
* must not be used.
***************************************/

#define emFile_SCB_SPI_0_SPIM_ACTIVE_SS0    (emFile_SCB_SPI_0_SPI_SLAVE_SELECT0)
#define emFile_SCB_SPI_0_SPIM_ACTIVE_SS1    (emFile_SCB_SPI_0_SPI_SLAVE_SELECT1)
#define emFile_SCB_SPI_0_SPIM_ACTIVE_SS2    (emFile_SCB_SPI_0_SPI_SLAVE_SELECT2)
#define emFile_SCB_SPI_0_SPIM_ACTIVE_SS3    (emFile_SCB_SPI_0_SPI_SLAVE_SELECT3)

#endif /* CY_SCB_SPI_UART_emFile_SCB_SPI_0_H */


/* [] END OF FILE */
