/*******************************************************************************
* File Name: emFile_SPI1_SPI_UART_PVT.h
* Version 3.0
*
* Description:
*  This private file provides constants and parameter values for the
*  SCB Component in SPI and UART modes.
*  Please do not use this file or its content in your project.
*
* Note:
*
********************************************************************************
* Copyright 2013-2015, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_SPI_UART_PVT_emFile_SPI1_H)
#define CY_SCB_SPI_UART_PVT_emFile_SPI1_H

#include "emFile_SPI1_SPI_UART.h"


/***************************************
*     Internal Global Vars
***************************************/

#if (emFile_SPI1_INTERNAL_RX_SW_BUFFER_CONST)
    extern volatile uint32  emFile_SPI1_rxBufferHead;
    extern volatile uint32  emFile_SPI1_rxBufferTail;
    extern volatile uint8   emFile_SPI1_rxBufferOverflow;
#endif /* (emFile_SPI1_INTERNAL_RX_SW_BUFFER_CONST) */

#if (emFile_SPI1_INTERNAL_TX_SW_BUFFER_CONST)
    extern volatile uint32  emFile_SPI1_txBufferHead;
    extern volatile uint32  emFile_SPI1_txBufferTail;
#endif /* (emFile_SPI1_INTERNAL_TX_SW_BUFFER_CONST) */

#if (emFile_SPI1_INTERNAL_RX_SW_BUFFER)
    extern volatile uint8 emFile_SPI1_rxBufferInternal[emFile_SPI1_INTERNAL_RX_BUFFER_SIZE];
#endif /* (emFile_SPI1_INTERNAL_RX_SW_BUFFER) */

#if (emFile_SPI1_INTERNAL_TX_SW_BUFFER)
    extern volatile uint8 emFile_SPI1_txBufferInternal[emFile_SPI1_TX_BUFFER_SIZE];
#endif /* (emFile_SPI1_INTERNAL_TX_SW_BUFFER) */


/***************************************
*     Private Function Prototypes
***************************************/

void emFile_SPI1_SpiPostEnable(void);
void emFile_SPI1_SpiStop(void);

#if (emFile_SPI1_SCB_MODE_SPI_CONST_CFG)
    void emFile_SPI1_SpiInit(void);
#endif /* (emFile_SPI1_SCB_MODE_SPI_CONST_CFG) */

#if (emFile_SPI1_SPI_WAKE_ENABLE_CONST)
    void emFile_SPI1_SpiSaveConfig(void);
    void emFile_SPI1_SpiRestoreConfig(void);
#endif /* (emFile_SPI1_SPI_WAKE_ENABLE_CONST) */

void emFile_SPI1_UartPostEnable(void);
void emFile_SPI1_UartStop(void);

#if (emFile_SPI1_SCB_MODE_UART_CONST_CFG)
    void emFile_SPI1_UartInit(void);
#endif /* (emFile_SPI1_SCB_MODE_UART_CONST_CFG) */

#if (emFile_SPI1_UART_WAKE_ENABLE_CONST)
    void emFile_SPI1_UartSaveConfig(void);
    void emFile_SPI1_UartRestoreConfig(void);
#endif /* (emFile_SPI1_UART_WAKE_ENABLE_CONST) */


/***************************************
*         UART API Constants
***************************************/

/* UART RX and TX position to be used in emFile_SPI1_SetPins() */
#define emFile_SPI1_UART_RX_PIN_ENABLE    (emFile_SPI1_UART_RX)
#define emFile_SPI1_UART_TX_PIN_ENABLE    (emFile_SPI1_UART_TX)

/* UART RTS and CTS position to be used in  emFile_SPI1_SetPins() */
#define emFile_SPI1_UART_RTS_PIN_ENABLE    (0x10u)
#define emFile_SPI1_UART_CTS_PIN_ENABLE    (0x20u)


/***************************************
* The following code is DEPRECATED and
* must not be used.
***************************************/

/* Interrupt processing */
#define emFile_SPI1_SpiUartEnableIntRx(intSourceMask)  emFile_SPI1_SetRxInterruptMode(intSourceMask)
#define emFile_SPI1_SpiUartEnableIntTx(intSourceMask)  emFile_SPI1_SetTxInterruptMode(intSourceMask)
uint32  emFile_SPI1_SpiUartDisableIntRx(void);
uint32  emFile_SPI1_SpiUartDisableIntTx(void);


#endif /* (CY_SCB_SPI_UART_PVT_emFile_SPI1_H) */


/* [] END OF FILE */
