/*******************************************************************************
* File Name: emFile_UDB_SPI_clk_0.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_emFile_UDB_SPI_clk_0_H)
#define CY_CLOCK_emFile_UDB_SPI_clk_0_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void emFile_UDB_SPI_clk_0_StartEx(uint32 alignClkDiv);
#define emFile_UDB_SPI_clk_0_Start() \
    emFile_UDB_SPI_clk_0_StartEx(emFile_UDB_SPI_clk_0__PA_DIV_ID)

#else

void emFile_UDB_SPI_clk_0_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void emFile_UDB_SPI_clk_0_Stop(void);

void emFile_UDB_SPI_clk_0_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 emFile_UDB_SPI_clk_0_GetDividerRegister(void);
uint8  emFile_UDB_SPI_clk_0_GetFractionalDividerRegister(void);

#define emFile_UDB_SPI_clk_0_Enable()                         emFile_UDB_SPI_clk_0_Start()
#define emFile_UDB_SPI_clk_0_Disable()                        emFile_UDB_SPI_clk_0_Stop()
#define emFile_UDB_SPI_clk_0_SetDividerRegister(clkDivider, reset)  \
    emFile_UDB_SPI_clk_0_SetFractionalDividerRegister((clkDivider), 0u)
#define emFile_UDB_SPI_clk_0_SetDivider(clkDivider)           emFile_UDB_SPI_clk_0_SetDividerRegister((clkDivider), 1u)
#define emFile_UDB_SPI_clk_0_SetDividerValue(clkDivider)      emFile_UDB_SPI_clk_0_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define emFile_UDB_SPI_clk_0_DIV_ID     emFile_UDB_SPI_clk_0__DIV_ID

#define emFile_UDB_SPI_clk_0_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define emFile_UDB_SPI_clk_0_CTRL_REG   (*(reg32 *)emFile_UDB_SPI_clk_0__CTRL_REGISTER)
#define emFile_UDB_SPI_clk_0_DIV_REG    (*(reg32 *)emFile_UDB_SPI_clk_0__DIV_REGISTER)

#define emFile_UDB_SPI_clk_0_CMD_DIV_SHIFT          (0u)
#define emFile_UDB_SPI_clk_0_CMD_PA_DIV_SHIFT       (8u)
#define emFile_UDB_SPI_clk_0_CMD_DISABLE_SHIFT      (30u)
#define emFile_UDB_SPI_clk_0_CMD_ENABLE_SHIFT       (31u)

#define emFile_UDB_SPI_clk_0_CMD_DISABLE_MASK       ((uint32)((uint32)1u << emFile_UDB_SPI_clk_0_CMD_DISABLE_SHIFT))
#define emFile_UDB_SPI_clk_0_CMD_ENABLE_MASK        ((uint32)((uint32)1u << emFile_UDB_SPI_clk_0_CMD_ENABLE_SHIFT))

#define emFile_UDB_SPI_clk_0_DIV_FRAC_MASK  (0x000000F8u)
#define emFile_UDB_SPI_clk_0_DIV_FRAC_SHIFT (3u)
#define emFile_UDB_SPI_clk_0_DIV_INT_MASK   (0xFFFFFF00u)
#define emFile_UDB_SPI_clk_0_DIV_INT_SHIFT  (8u)

#else 

#define emFile_UDB_SPI_clk_0_DIV_REG        (*(reg32 *)emFile_UDB_SPI_clk_0__REGISTER)
#define emFile_UDB_SPI_clk_0_ENABLE_REG     emFile_UDB_SPI_clk_0_DIV_REG
#define emFile_UDB_SPI_clk_0_DIV_FRAC_MASK  emFile_UDB_SPI_clk_0__FRAC_MASK
#define emFile_UDB_SPI_clk_0_DIV_FRAC_SHIFT (16u)
#define emFile_UDB_SPI_clk_0_DIV_INT_MASK   emFile_UDB_SPI_clk_0__DIVIDER_MASK
#define emFile_UDB_SPI_clk_0_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_emFile_UDB_SPI_clk_0_H) */

/* [] END OF FILE */
